function Iout = SimplestColorBalance(Iin,w_clip,k_clip)
% Iout = SimplestColorBalance(Iin,w_clip,k_clip)
% L'image Iin doit ??tre dans [0,1]
% Le 16 juillet 2015, CMLA
% D'apr??s l'article d'IPOL du m??me nom
%
% See "ipolSCB" for the Simplest Color Balance closer to the original.

[H,X]    = hist(Iin(:),1024);
histocum = cumsum(H(:));
N        = numel(Iin);
[~,imax] = max(histocum >= ceil((1-w_clip)*N));
[~,imin] = max(histocum > floor((0+k_clip)*N));
if imin~=1, imin=imin-1; end
gap      = (max(Iin(:))-min(Iin(:)))/2048;
vmax     = X(imax) + gap;
vmin     = X(imin) - gap;

Iout     = (Iin-vmin)/(vmax - vmin);

% v??rification :
fprintf('---- Simplest Color Balance ----\n');
fprintf('Nb of white clipped px: %06.3f %%\n', 100*sum(Iout(:) > 1)/N);
fprintf('Nb of black clipped px: %06.3f %%\n', 100*sum(Iout(:) < 0)/N);
fprintf('imgOut = (imgIn - %.3f)/%.3f\n', vmin, vmax - vmin);
fprintf('--------------------------------\n');

% Saturation :
Iout(Iout > 1) = 1;
Iout(Iout < 0) = 0;

end
