function [file_list, nb_of_files] = findImages(file_list, nb_of_files, wd)

% Note: would be way more simple with dir('**/*.jpg') but it doesn't work
% %%%%% on ipol servers (don't know why).

%%%% 1) Add local images to file_list

% Accepted inputs. The PNG, JPEG, etc equivalents will be recognized.
localImg = cat(1, dir([wd '/*.png']), ...
                  dir([wd '/*.jpg']), dir([wd '/*.jpeg']), ...
                  dir([wd '/*.tif']), dir([wd '/*.tiff'])  );
nb_imgs  = length(localImg);
% Reject files starting by '~' or '.'
n = 1;
while( n <= nb_imgs )
    if ( localImg(n).name(1) == '~' || localImg(n).name(1) == '.' )
        localImg = cat(1,localImg(1:(n-1)),localImg((n+1):end));
        nb_imgs  = nb_imgs-1;
        n        = n-1;
    else
        localImg(n).name = [wd '/' localImg(n).name];
    end
n = n+1;
end;

%%%% 2) Explore (recursively) the directories

localDir = dir(wd);
localDir = localDir( [localDir.isdir] == true );
nb_dirs  = length(localDir);
% Reject unwanted entries ('.*' directories):
n = 1;
while( n <= nb_dirs )
    if strcmp(localDir(n).name(1),'.')
        localDir = cat(1,localDir(1:(n-1)),localDir((n+1):end));
        nb_dirs  = nb_dirs-1;
        n        = n-1;
    end
n = n+1;
end;

% Update file_list nb_of_fiels with new images
if nb_imgs
    file_list   = cat(1, file_list, localImg );
    nb_of_files = nb_of_files + nb_imgs;
end

% For each dir, find image
for k=1:nb_dirs
    [file_list, nb_of_files] = ...
        findImages(file_list, nb_of_files, [wd '/' localDir(k).name]);
end
end